FC v. 3.03 (c) 2004 Maurizio Spagni

FC compare deux fichiers ou jeux de fichiers, en mode texte ou binaire, et
affiche leurs diffrences.

FC implmente l'algorithme de Paul Heckel dcrit dans Communications of the
Association for Computing Machinery, avril 1978, p264 - p268,
"A Technique for Isolating Differences Between Files", c'est--dire "Une
technique pour isoler les diffrences entre des fichiers".

L'avantage de cet algorithme sur les algorithmes plus communment utiliss est
qu'il est rapide et qu'il peut dtecter les diffrences dans un nombre
arbitraire de lignes. Pour la plupart des applications l'algorithme isole les
diffrences similaires  celles isoles par sous-squence commune la plus
longue.

La syntaxe est la suivante :

FC [options] [lecteur1:][chemin1]nomfich1 [lecteur2][chemin2]nomfich2 [options]

 /A    N'afficher que la premire et dernire ligne pour chaque jeu de diff
 /B    Effectuer une comparaison binaire
 /C    Ne pas prendre en compte la casse des lettres
 /L    Comparer les fichiers en tant que texte ASCII
 /LBn  Dfinir le nombre maximum de lignes ASCII diffrentes conscutives sur n
 /Mn   Dfinir les diffrences maximales de comparaison binaire  n octets
 /N    Afficher les numros de ligne lors d'une comparaison de texte
 /Q    Ne pas afficher la liste des diffrences
 /R    Afficher un bref rapport final (tojours actif avec /S)
 /S    tendre l'analyse aux fichiers dans les sous-rpertoires
 /T    Ne pas dvelopper les tabulations en espaces
 /U    Afficher les noms des fichiers pour les fichiers sans correspondant
 /W    Empaqueter les espaces blancs (tabulations et espaces) pour la
       comparaison de texte
 /X    Ne pas afficher le contexte dans la comparaison de texte
 /nnn  Dfinir le nombre minimum de lignes correspondantes conscutives sur nnn
       pour la resynchronisation de la comparaison

Le programme prend en charge le LFN et l'utilise automatiquement si le systme
d'exploitation prend en charge les noms de fichiers longs.

FC utilise par dfaut le mode binaire pour les fichiers .EXE, .COM, .SYS, .OBJ,
.BIN, .DLL et .LIB.

En mode binaire, FC affiche le dcalage des octets diffrents dans le fichier,
leur valeur en hexadcimal et s'il s'agit de caractres ASCII imprimables, leur
caractre ASCII.

Par dfaut, la comparaison binaire s'arrte au bout de 20 diffrences mais
cette valeur peut tre modifie avec l'option /M. /M0 signifie "diffrences
illimites", /M est interprte comme /M0.

Une limitation de conception de ce programme est que, en mode de comparaison de
fichier texte, seules les 32765 premires lignes seront compares, les lignes
restantes seront ignores. La longueur de la ligne est virtuellement illimite.

FC prend en charge les jokers dans les spcifications de fichiers. Quelques
mots l-dessus :
- spcifier un rpertoire revient  spcifier tous les fichiers dans ce
  rpertoire (c'est--dire "*.*").
  Exemple : "FC C:\ A:" quivaut  "FC C:\*.* A:*.*"
- si aucun nomfichier2 n'est entr, alors "." (le rpertoire courant) est
  suppos.
  Exemple : "FC C:\FOO.TXT" quivaut  "FC C:\FOO.TXT .\*.*"
- si nomfichier1 a des jokers mais nomfichier2 n'en a pas, alors tous les
  fichiers correspondant  nomfichier1 sont compars avec nomfichiers2.
  Exemple : "FC FOO.BK? FOO.TXT"
	   Tous les fichiers FOO.BK? seront compars avec with FOO.TXT
- si nomfichiers1 a des jokers et nomfichier2 est un chemin suivi par "*.*"
  alors tous les fichiers correspondant  nomfichier1 seront compars avec les
  fichiers du mme nom mais dans le chemin spcifi par nomfichier2 (si ce
  fichier existe, bien entendu).
  Exemple : "FC *.* A:*.*" ou, en version courte, "FC . A:"
	   Tous les fichiers dans le rpertoire courant seront compars avec leur
	   copie sur A:
- si nomfichier1 a des jokers et nomfichier2 en a aussi, alors tous les
  fichiers sur le chemin de nomfichier1 et correspondant  nomfichier1 seront
  compars avec le fichier correspondant  nomfichier2 sur le chemin spcifi
  par nomfichier2 (si ce fichier existe, bien entendu).
  Exemple : "FC *.TXT OLDS\*.BAK"
	   Tous les fichiers dans le rpertoire courant seront compars avec leur
	   copie de sauvegarde renomme en .BAK dans le sous-rpertoire OLDS.
C'est plus facile  faire qu' dire.
Si ce que vous souhaitez vraiment est de comparer chaque fichier dans un
rpertoire avec tous les fichiers dans un autre rpertoire, vous pouvez
toujours utiliser la forme :
FC *.* MYDIR\????????.???

L'option /S itre le mme modle de recherche dans les sous-rpertoires avec le
mme nom sur les deux chemins.
  Exemple : "FC /S C:*.TXT D:*.BAK"
	   En supposant par exemple l'existence des sous-rpertoires C:BOOK et
	   D:BOOK, cette commande compare tous les fichiers *.TXT avec leurs copies
	   de sauvegarde *.BAK dans les sous-rpertoires courants et galement tous
	   les fichiers BOOK\*.TXT avec leurs copies de sauvegarde BOOK\*.BAK.

Les codes de sortie pour le niveau d'erreur (ERRORLEVEL) sont les suivants :
	0	Tous les fichiers correspondent
	1	Au moins une paire de fichiers diffre
	2	Paramtre invalide sur la ligne de commande
	3	Fichier introuvable
	4	Erreur lors de l'ouverture de(s) fichier(s)
